<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Pass StructType
 * @subpackage Structs
 */
class Pass extends AbstractStructBase
{
    /**
     * The startAz
     * @var float
     */
    public $startAz;
    /**
     * The startEl
     * @var float
     */
    public $startEl;
    /**
     * The startAzCompass
     * @var string
     */
    public $startAzCompass;
    /**
     * The startUTC
     * @var string
     */
    public $startUTC;
    /**
     * The maxAz
     * @var float
     */
    public $maxAz;
    /**
     * The maxAzCompass
     * @var string
     */
    public $maxAzCompass;
    /**
     * The maxEl
     * @var float
     */
    public $maxEl;
    /**
     * The maxUTC
     * @var string
     */
    public $maxUTC;
    /**
     * The endAz
     * @var float
     */
    public $endAz;
    /**
     * The endEl
     * @var float
     */
    public $endEl;
    /**
     * The endAzCompass
     * @var string
     */
    public $endAzCompass;
    /**
     * The endUTC
     * @var string
     */
    public $endUTC;
    /**
     * The mag
     * @var float
     */
    public $mag;
    /**
     * The duration
     * @var string
     */
    public $duration;
    /**
     * Constructor method for Pass
     * @uses Pass::setStartAz()
     * @uses Pass::setStartEl()
     * @uses Pass::setStartAzCompass()
     * @uses Pass::setStartUTC()
     * @uses Pass::setMaxAz()
     * @uses Pass::setMaxAzCompass()
     * @uses Pass::setMaxEl()
     * @uses Pass::setMaxUTC()
     * @uses Pass::setEndAz()
     * @uses Pass::setEndEl()
     * @uses Pass::setEndAzCompass()
     * @uses Pass::setEndUTC()
     * @uses Pass::setMag()
     * @uses Pass::setDuration()
     * @param float $startAz
     * @param float $startEl
     * @param string $startAzCompass
     * @param string $startUTC
     * @param float $maxAz
     * @param string $maxAzCompass
     * @param float $maxEl
     * @param string $maxUTC
     * @param float $endAz
     * @param float $endEl
     * @param string $endAzCompass
     * @param string $endUTC
     * @param float $mag
     * @param string $duration
     */
    public function __construct($startAz = null, $startEl = null, $startAzCompass = null, $startUTC = null, $maxAz = null, $maxAzCompass = null, $maxEl = null, $maxUTC = null, $endAz = null, $endEl = null, $endAzCompass = null, $endUTC = null, $mag = null, $duration = null)
    {
        $this
            ->setStartAz($startAz)
            ->setStartEl($startEl)
            ->setStartAzCompass($startAzCompass)
            ->setStartUTC($startUTC)
            ->setMaxAz($maxAz)
            ->setMaxAzCompass($maxAzCompass)
            ->setMaxEl($maxEl)
            ->setMaxUTC($maxUTC)
            ->setEndAz($endAz)
            ->setEndEl($endEl)
            ->setEndAzCompass($endAzCompass)
            ->setEndUTC($endUTC)
            ->setMag($mag)
            ->setDuration($duration);
    }
    /**
     * Get startAz value
     * @return float|null
     */
    public function getStartAz()
    {
        return $this->startAz;
    }
    /**
     * Set startAz value
     * @param float $startAz
     * @return \StructType\Pass
     */
    public function setStartAz($startAz = null)
    {
        $this->startAz = $startAz;
        return $this;
    }
    /**
     * Get startEl value
     * @return float|null
     */
    public function getStartEl()
    {
        return $this->startEl;
    }
    /**
     * Set startEl value
     * @param float $startEl
     * @return \StructType\Pass
     */
    public function setStartEl($startEl = null)
    {
        $this->startEl = $startEl;
        return $this;
    }
    /**
     * Get startAzCompass value
     * @return string|null
     */
    public function getStartAzCompass()
    {
        return $this->startAzCompass;
    }
    /**
     * Set startAzCompass value
     * @param string $startAzCompass
     * @return \StructType\Pass
     */
    public function setStartAzCompass($startAzCompass = null)
    {
        // validation for constraint: string
        if (!is_null($startAzCompass) && !is_string($startAzCompass)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startAzCompass)), __LINE__);
        }
        $this->startAzCompass = $startAzCompass;
        return $this;
    }
    /**
     * Get startUTC value
     * @return string|null
     */
    public function getStartUTC()
    {
        return $this->startUTC;
    }
    /**
     * Set startUTC value
     * @param string $startUTC
     * @return \StructType\Pass
     */
    public function setStartUTC($startUTC = null)
    {
        // validation for constraint: string
        if (!is_null($startUTC) && !is_string($startUTC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startUTC)), __LINE__);
        }
        $this->startUTC = $startUTC;
        return $this;
    }
    /**
     * Get maxAz value
     * @return float|null
     */
    public function getMaxAz()
    {
        return $this->maxAz;
    }
    /**
     * Set maxAz value
     * @param float $maxAz
     * @return \StructType\Pass
     */
    public function setMaxAz($maxAz = null)
    {
        $this->maxAz = $maxAz;
        return $this;
    }
    /**
     * Get maxAzCompass value
     * @return string|null
     */
    public function getMaxAzCompass()
    {
        return $this->maxAzCompass;
    }
    /**
     * Set maxAzCompass value
     * @param string $maxAzCompass
     * @return \StructType\Pass
     */
    public function setMaxAzCompass($maxAzCompass = null)
    {
        // validation for constraint: string
        if (!is_null($maxAzCompass) && !is_string($maxAzCompass)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maxAzCompass)), __LINE__);
        }
        $this->maxAzCompass = $maxAzCompass;
        return $this;
    }
    /**
     * Get maxEl value
     * @return float|null
     */
    public function getMaxEl()
    {
        return $this->maxEl;
    }
    /**
     * Set maxEl value
     * @param float $maxEl
     * @return \StructType\Pass
     */
    public function setMaxEl($maxEl = null)
    {
        $this->maxEl = $maxEl;
        return $this;
    }
    /**
     * Get maxUTC value
     * @return string|null
     */
    public function getMaxUTC()
    {
        return $this->maxUTC;
    }
    /**
     * Set maxUTC value
     * @param string $maxUTC
     * @return \StructType\Pass
     */
    public function setMaxUTC($maxUTC = null)
    {
        // validation for constraint: string
        if (!is_null($maxUTC) && !is_string($maxUTC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maxUTC)), __LINE__);
        }
        $this->maxUTC = $maxUTC;
        return $this;
    }
    /**
     * Get endAz value
     * @return float|null
     */
    public function getEndAz()
    {
        return $this->endAz;
    }
    /**
     * Set endAz value
     * @param float $endAz
     * @return \StructType\Pass
     */
    public function setEndAz($endAz = null)
    {
        $this->endAz = $endAz;
        return $this;
    }
    /**
     * Get endEl value
     * @return float|null
     */
    public function getEndEl()
    {
        return $this->endEl;
    }
    /**
     * Set endEl value
     * @param float $endEl
     * @return \StructType\Pass
     */
    public function setEndEl($endEl = null)
    {
        $this->endEl = $endEl;
        return $this;
    }
    /**
     * Get endAzCompass value
     * @return string|null
     */
    public function getEndAzCompass()
    {
        return $this->endAzCompass;
    }
    /**
     * Set endAzCompass value
     * @param string $endAzCompass
     * @return \StructType\Pass
     */
    public function setEndAzCompass($endAzCompass = null)
    {
        // validation for constraint: string
        if (!is_null($endAzCompass) && !is_string($endAzCompass)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endAzCompass)), __LINE__);
        }
        $this->endAzCompass = $endAzCompass;
        return $this;
    }
    /**
     * Get endUTC value
     * @return string|null
     */
    public function getEndUTC()
    {
        return $this->endUTC;
    }
    /**
     * Set endUTC value
     * @param string $endUTC
     * @return \StructType\Pass
     */
    public function setEndUTC($endUTC = null)
    {
        // validation for constraint: string
        if (!is_null($endUTC) && !is_string($endUTC)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endUTC)), __LINE__);
        }
        $this->endUTC = $endUTC;
        return $this;
    }
    /**
     * Get mag value
     * @return float|null
     */
    public function getMag()
    {
        return $this->mag;
    }
    /**
     * Set mag value
     * @param float $mag
     * @return \StructType\Pass
     */
    public function setMag($mag = null)
    {
        $this->mag = $mag;
        return $this;
    }
    /**
     * Get duration value
     * @return string|null
     */
    public function getDuration()
    {
        return $this->duration;
    }
    /**
     * Set duration value
     * @param string $duration
     * @return \StructType\Pass
     */
    public function setDuration($duration = null)
    {
        // validation for constraint: string
        if (!is_null($duration) && !is_string($duration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($duration)), __LINE__);
        }
        $this->duration = $duration;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Pass
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
